// Game example
// A platform game, horizontal scrolling

// first, let's make a generative "landscape" with platforms
// each platform will be an object with an x, y, and w parameter

var platforms = [];
var marioY = 0;     // start mario character at top

/////// PLATFORM OBJECT CODE /////

function newPlatform(px, py, pw) {
    var p = {x: px, y: py, w: pw,
             right: platRight};
    return p;
}

// compute the location of the right end of a platform
function platRight() {
    return this.x + this.w;
}

///////////////////////////////////


function setup() {
    createCanvas(600, 300);
    var pl = newPlatform(600, 200, 200);  // first platform
    platforms.push(pl);
}

function draw() {
    background("lightblue");
    fill("green");
    stroke("green");
    rect(0, height - 50, width, 50); // the ground
    
    fill(0);
    stroke(0);
    for (var i = 0; i < platforms.length; i++) {
        var p = platforms[i];
        p.x = p.x - 1;
        rect(p.x, p.y, p.w, 10);
    }

    // if first platform is offscreen to left, remove it
    if (platforms.length > 0 && platforms[0].right() < 0) {
        platforms.shift();
    }

    // if last platform is totally within canvas, make a new one
    var lastPlat = platforms[platforms.length-1];
    if (lastPlat.right() == width - 1) {
        var p = newPlatform(
              width, // left edge just off campus
              floor(random(50, 225)), // height of new platform
              200); // all platforms have width 200 for now
        platforms.push(p); // add to our array of platforms
    }

    // NEW CODE
    // move and draw the character "mario"
    // use linear search to find platform in the middle of canvas
    var i = 0;
    var marioX = width / 2;
    while (platforms[i].right() < marioX) {
        i += 1;
    }
    // (there's a bug here!)
    // now i is index of the platform in the middle of canvas
    // find the platform height
    var py = platforms[i].y;

    // show some debugging information for now
    text(" platform " + i + " py " + py, 10, 50);
 
    // "mario" falls
    if (marioY == py) {
        marioY = py;    // on the platform, don't change marioY
    } else if (marioY == height) {
        marioY = 0;     // "dies", reemerge at top of canvas
    } else {
        marioY += 1;    // otherwise, "fall" one pixel
    }

    // draw the "mario"
    fill("brown");
    stroke("brown");
    rect(marioX, marioY - 20, 20, 20);

    //debugging:
    text(platforms.length.toString() + " platform(s)", 10, 30);

}

